package jtail;

import java.io.*;
import java.util.*;

import java.awt.*;
import java.awt.dnd.*;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.event.*;

import javax.swing.*;

public class JTailFrame extends JFrame implements Observer
{
	// eLXg\
	private JEditorPane editorPane;

	// f[^
	private JTailData data;

	// ^C}
	private javax.swing.Timer timer;

	/**
	 *	ftHgRXgN^
	 */
	public JTailFrame()
	{
		// EChȄݒ
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setSize(600, 400);
		setTitle("JTail");

		// R|[lg̍쐬
		editorPane = new JEditorPane("text/html", "");
		editorPane.setEditable(false);

		// hbv^[Qbg̓o^
		addDropTarget(editorPane);

		// XN[yC̍쐬
		JScrollPane scrollPane = new JScrollPane(editorPane);
		setContentPane(scrollPane);

		// j[̍쐬Ɠo^
		JMenuBar menuBar = new JMenuBar();
		JMenu fileMenu = createFileMenu();
		menuBar.add(fileMenu);
		setJMenuBar(menuBar);

		// f[^̏ƃtB^̐ݒ
		try
		{
			data = ConfigReader.readConfig(new File("conf.xml"));
		}
		catch(Exception ex)
		{
			ex.printStackTrace();
		}

		// \
		setVisible(true);
	}

	/**
	 *	ύXۂɏs\bh
	 */
	public void update(Observable o, Object arg)
	{
		// eLXg擾
		String diffText = (String)arg;

		// eLXgfɒǉ
		data.appendText(diffText);

		try
		{
			// \f[^f擾Ar[ɃZbg
			editorPane.setText(data.getEditedString());
		}
		catch(IOException io_ex)
		{
			io_ex.printStackTrace();
		}
	}

	/**
	 *	t@Cj[̍\z
	 */
	private JMenu createFileMenu()
	{
		JMenu menu = new JMenu("t@C");

		// Jj[̒ǉ
		JMenuItem fileOpen = new JMenuItem("J...");
		fileOpen.addActionListener(
			new ActionListener(){
				public void actionPerformed(ActionEvent ae)
				{
					JFileChooser fileChooser = new JFileChooser();
					int ret = fileChooser.showOpenDialog(JTailFrame.this);
					if(ret == JFileChooser.APPROVE_OPTION)
					{
						JTailFrame.this.selectFile(fileChooser.getSelectedFile());
					}
				}
			}
		);
		menu.add(fileOpen);

		// Zp[^
		menu.addSeparator();

		// Ij[̒ǉ
		JMenuItem fileExit = new JMenuItem("I");
		fileExit.addActionListener(
			new ActionListener(){
				public void actionPerformed(ActionEvent ae)
				{
					System.exit(0);
				}
			}
		);
		menu.add(fileExit);

		return menu;
	}

	/**
	 *	t@CIꂽ̏
	 */
	public void selectFile(File file)
	{
		// ɉғ̃^C}΁A܂~߂B
		if(timer != null && timer.isRunning())
			timer.stop();

		// fr[NA
		data.clear();
		editorPane.setText("");

		// ^C}̓o^
		ReadFileTask task = new ReadFileTask(file.getAbsolutePath());
		task.addObserver(this);
		timer = new javax.swing.Timer(data.getInterval(), task);
		timer.start();
	}

	/**
	 *	G[bZ[W_CAO
	 */
	public void showErrorDialog(String errorMessage)
	{
	}

	/**
	 *	hbv^[Qbg̓o^
	 */
	public void addDropTarget(Component c)
	{
		// hbv^[Qbg̒`
		DropTarget target = new DropTarget(c, DnDConstants.ACTION_REFERENCE, new DropTargetListener()
		{
			public void dragEnter(DropTargetDragEvent enter)
			{
			}

			public void dragOver(DropTargetDragEvent over)
			{
			}

			public void dropActionChanged(DropTargetDragEvent action)
			{
			}

			public void dragExit(DropTargetEvent exit)
			{
			}

			// hbvꂽɃR[
			public void drop(DropTargetDropEvent drop)
			{
				try
				{
					Transferable transfer = drop.getTransferable();
					if(transfer.isDataFlavorSupported(DataFlavor.javaFileListFlavor))
					{
						// hbvꂽf[^̎擾
						drop.acceptDrop(DnDConstants.ACTION_REFERENCE);

						java.util.List file_list = (java.util.List)transfer.getTransferData(DataFlavor.javaFileListFlavor);
						String file_name = file_list.get(0).toString();
						JTailFrame.this.selectFile(new File(file_name));

						drop.getDropTargetContext().dropComplete(true);
					}
				}
				catch(Exception e)
				{
					System.err.println(e);
				}
			}
		});
	}
}
